Index: asterisk.sgml
===================================================================
--- asterisk.sgml	(revision 308567)
+++ asterisk.sgml	(working copy)
@@ -1,424 +0,0 @@
-<refentry>
-<refentryinfo>
-	<date>2010-08-03</date>
-</refentryinfo>
-<refmeta>
-	<refentrytitle>
-		<application>asterisk</application>
-	</refentrytitle>
-	<manvolnum>8</manvolnum>
-	<refmiscinfo>asterisk 1.6</refmiscinfo>
-</refmeta>
-<refnamediv>
-	<refname>
-		<application>asterisk</application>
-	</refname>
-	<refpurpose>
-	All-purpose telephony server.
-	</refpurpose>
-</refnamediv>
-<refsynopsisdiv>
-	<cmdsynopsis>
-	<command>asterisk</command>
-<arg><option>-BcdfFghiImnpqRtTvVW</option></arg>
-<arg><option>-C </option><replaceable class="parameter">file</replaceable></arg>
-<arg><option>-e </option><replaceable class="parameter">memory</replaceable></arg>
-<arg><option>-G </option><replaceable class="parameter">group</replaceable></arg>
-<arg><option>-L </option><replaceable class="parameter">loadaverage</replaceable></arg>
-<arg><option>-M </option><replaceable class="parameter">value</replaceable></arg>
-<arg><option>-U </option><replaceable class="parameter">user</replaceable></arg>
-<arg><option>-s </option><replaceable class="parameter">socket-file</replaceable></arg>
-<arg><option>-x </option><replaceable class="parameter">command</replaceable></arg>
-	</cmdsynopsis>
-	<cmdsynopsis>
-
-	<command>asterisk -r</command>
-	<arg><option>-v</option></arg>
-<arg><option>-x </option><replaceable class="parameter">command</replaceable></arg>
-	</cmdsynopsis>
-</refsynopsisdiv>
-<refsect1>
-	<refsect1info>
-		<date>2010-08-03</date>
-	</refsect1info>
-	<title>DESCRIPTION</title>
-	<para>
-	<command>asterisk</command> is a full-featured telephony server which
-	provides Private Branch eXchange (PBX), Interactive Voice Response (IVR),
-	Automated Call Distribution (ACD), Voice over IP (VoIP) gatewaying, 
-	Conferencing, and a plethora of other telephony applications to a broad
-	range of telephony devices including packet voice (SIP, IAX2, MGCP, Skinny,
-	H.323, Unistim) devices (both endpoints and proxies), as well as traditional TDM
-	hardware including T1, E1, ISDN PRI, GR-303, RBS, Loopstart, Groundstart,
-	ISDN BRI and many more.
-	</para>
-	<para>
-	At start, Asterisk reads the /etc/asterisk/asterisk.conf main configuration
-	file and locates the rest of the configuration files from the configuration
-	in that file. The -C option specifies an alternate main configuration file.
-	Virtually all aspects of the operation of asterisk's configuration files
-	can be found in the sample configuration files.  The format for those files
-	is generally beyond the scope of this man page.
-	</para>
-	<para>
-	When running with <command>-c</command>, <command>-r</command> or <command>-R</command>
-	options, Asterisk supplies a powerful command line, including command
-	completion, which may be used to monitors its status, perform a variety
-	of administrative actions and even explore the applications that are
-	currently loaded into the system.
-	</para>
-	<para>
-	Asterisk is a trademark of Digium, Inc.
-	</para>
-</refsect1>
-<refsect1>
-	<title>OPTIONS</title>
-	<variablelist>
-	<varlistentry>
-		<term>-B</term>
-		<listitem>
-			<para>
-			Force the background of the terminal to be black, in order for
-			terminal colors to show up properly.
-			</para>
-		</listitem>
-	</varlistentry>
-	<varlistentry>
-		<term>-C <replaceable class="parameter">file</replaceable></term>
-		<listitem>
-			<para>
-			Use <filename>file</filename> as master configuration file
-			instead of the default, /etc/asterisk/asterisk.conf
-			</para>
-		</listitem>
-	</varlistentry>
-	<varlistentry>
-		<term>-c</term>
-		<listitem>
-			<para>
-			Provide a control console on the calling terminal.
-			Specifying this option implies <command>-f</command> and will cause
-			asterisk to no longer fork or detach from the controlling terminal.
-			</para>
-		</listitem>
-	</varlistentry>
-	<varlistentry>
-		<term>-d</term>
-		<listitem>
-			<para>
-			Enable extra debugging statements.
-			</para>
-			<para>
-			Note: This always sets the debug level in the asterisk process,
-			even if it is running in the background. This may affect the size
-			of your log files, if the debug level is specified in logger.conf.
-			</para>
-		</listitem>
-	</varlistentry>
-	<varlistentry>
-		<term>-e <replaceable class="parameter">memory</replaceable></term>
-		<listitem>
-			<para>
-			Limit the generation of new channels when the amount of free memory has decreased to under <replaceable>memory</replaceable> megabytes.
-			</para>
-		</listitem>
-	</varlistentry>
-	<varlistentry>
-		<term>-f</term>
-		<listitem>
-			<para>
-			Do not fork or detach from controlling terminal.  Overrides any preceding specification of <command>-F</command> on the command line.
-			</para>
-		</listitem>
-	</varlistentry>
-	<varlistentry>
-		<term>-F</term>
-		<listitem>
-			<para>
-			Always fork and detach from controlling terminal.  Overrides any preceding specification of <command>-f</command> on the command line.
-			</para>
-		</listitem>
-	</varlistentry>
-	<varlistentry>
-		<term>-g</term>
-		<listitem>
-			<para>
-			Remove resource limit on core size, thus forcing Asterisk to dump
-			core in the unlikely event of a segmentation fault or abort signal.
-			<command>NOTE:</command> in some cases this may be incompatible
-			with the <command>-U</command> or <command>-G</command> flags.
-			</para>
-		</listitem>
-	</varlistentry>
-	<varlistentry>
-		<term>-G <replaceable class="parameter">group</replaceable></term>
-		<listitem>
-			<para>
-			Run as group <replaceable>group</replaceable> instead of the
-			calling group.  <command>NOTE:</command> this requires substantial work
-			to be sure that Asterisk's environment has permission to write
-			the files required for its operation, including logs, its comm
-			socket, the asterisk database, etc.
-			</para>
-		</listitem>
-	</varlistentry>
-	<varlistentry>
-		<term>-h</term>
-		<listitem>
-			<para>
-			Provide brief summary of command line arguments and terminate.
-			</para>
-		</listitem>
-	</varlistentry>
-	<varlistentry>
-		<term>-i</term>
-		<listitem>
-			<para>
-			Prompt user to intialize any encrypted private keys for IAX2
-			secure authentication during startup.
-			</para>
-		</listitem>
-	</varlistentry>
-	<varlistentry>
-		<term>-I</term>
-		<listitem>
-			<para>
-			Enable internal timing if DAHDI timing is available.
-			The default behaviour is that outbound packets are phase locked
-			to inbound packets. Enabling this switch causes them to be
-			locked to the internal DAHDI timer instead.
-			</para>
-		</listitem>
-	</varlistentry>
-	<varlistentry>
-		<term>-L <replaceable class="parameter">loadaverage</replaceable></term>
-		<listitem>
-			<para>
-			Limits the maximum load average before rejecting new calls.  This can
-			be useful to prevent a system from being brought down by terminating
-			too many simultaneous calls.
-			</para>
-		</listitem>
-	</varlistentry>
-	<varlistentry>
-		<term>-m</term>
-		<listitem>
-			<para>
-			Temporarily mutes output to the console and logs.  To return to normal,
-			use <command>logger mute</command>.
-			</para>
-		</listitem>
-	</varlistentry>
-	<varlistentry>
-		<term>-M <replaceable class="parameter">value</replaceable></term>
-		<listitem>
-			<para>
-			Limits the maximum number of calls to the specified value.  This can
-			be useful to prevent a system from being brought down by terminating
-			too many simultaneous calls.
-			</para>
-		</listitem>
-	</varlistentry>
-	<varlistentry>
-		<term>-n</term>
-		<listitem>
-			<para>
-			Disable ANSI colors even on terminals capable of displaying them.
-			</para>
-		</listitem>
-	</varlistentry>
-	<varlistentry>
-		<term>-p</term>
-		<listitem>
-			<para>
-			If supported by the operating system (and executing as root),
-			attempt to run with realtime priority for increased performance and
-			responsiveness within the Asterisk process, at the expense of other
-			programs running on the same machine.
-			</para>
-			<para>
-			Note: <command>astcanary</command> will run concurrently with
-			<command>asterisk</command>. If <command>astcanary</command> stops
-			running or is killed, <command>asterisk</command> will slow down to
-			normal process priority, to avoid locking up the machine.
-			</para>
-		</listitem>
-	</varlistentry>
-	<varlistentry>
-		<term>-q</term>
-		<listitem>
-			<para>
-			Reduce default console output when running in conjunction with
-			console mode (<command>-c</command>).
-			</para>
-		</listitem>
-	</varlistentry>
-	<varlistentry>
-		<term>-r</term>
-		<listitem>
-			<para>
-			Instead of running a new Asterisk process, attempt to connect
-			to a running Asterisk process and provide a console interface
-			for controlling it.
-			</para>
-		</listitem>
-	</varlistentry>
-	<varlistentry>
-		<term>-R</term>
-		<listitem>
-			<para>
-			Much like <command>-r</command>.  Instead of running a new Asterisk process, attempt to connect
-			to a running Asterisk process and provide a console interface
-			for controlling it. Additionally, if connection to the Asterisk 
-			process is lost, attempt to reconnect for as long as 30 seconds.
-			</para>
-		</listitem>
-	</varlistentry>
-	<varlistentry>
-		<term>-s <replaceable class="parameter">socket file name</replaceable></term>
-		<listitem>
-			<para>
-			In combination with <command>-r</command>, connect directly to a specified
-			Asterisk server socket.
-			</para>
-		</listitem>
-	</varlistentry>
-	<varlistentry>
-		<term>-t</term>
-		<listitem>
-			<para>
-			When recording files, write them first into a temporary holding directory, 
-			then move them into the final location when done.
-			</para>
-		</listitem>
-	</varlistentry>
-	<varlistentry>
-		<term>-T</term>
-		<listitem>
-			<para>
-			Add timestamp to all non-command related output going to the console
-			when running with verbose and/or logging to the console.
-			</para>
-		</listitem>
-	</varlistentry>
-	<varlistentry>
-		<term>-U <replaceable class="parameter">user</replaceable></term>
-		<listitem>
-			<para>
-			Run as user <replaceable>user</replaceable> instead of the
-			calling user.  <command>NOTE:</command> this requires substantial work
-			to be sure that Asterisk's environment has permission to write
-			the files required for its operation, including logs, its comm
-			socket, the asterisk database, etc.
-			</para>
-		</listitem>
-	</varlistentry>
-	<varlistentry>
-		<term>-v</term>
-		<listitem>
-			<para>
-			Increase the level of verboseness on the console.  The more times
-			<command>-v</command> is specified, the more verbose the output is.
-			Specifying this option implies <command>-f</command> and will cause
-			asterisk to no longer fork or detach from the controlling terminal.
-			This option may also be used in conjunction with <command>-r</command>
-			and <command>-R</command>.
-			</para>
-			<para>
-			Note: This always sets the verbose level in the asterisk process,
-			even if it is running in the background. This will affect the size
-			of your log files.
-			</para>
-		</listitem>
-	</varlistentry>
-	<varlistentry>
-		<term>-V</term>
-		<listitem>
-			<para>
-			Display version information and exit immediately.
-			</para>
-		</listitem>
-	</varlistentry>
-	<varlistentry>
-		<term>-W</term>
-		<listitem>
-			<para>
-			Display colored terminal text as if the background were white
-			or otherwise light in color.  Normally, terminal text is displayed
-			as if the background were black or otherwise dark in color.
-			</para>
-		</listitem>
-	</varlistentry>
-	<varlistentry>
-		<term>-x <replaceable class="parameter">command</replaceable></term>
-		<listitem>
-			<para>
-			Connect to a running Asterisk process and execute a command on
-			a command line, passing any output through to standard out and
-			then terminating when the command execution completes.  Implies
-			<command>-r</command> when <command>-R</command> is not explicitly
-			supplied.
-			</para>
-		</listitem>
-	</varlistentry>
-	</variablelist>
-</refsect1>
-<refsect1>
-	<title>EXAMPLES</title>
-	<para>
-	<command>asterisk</command> - Begin Asterisk as a daemon
-	</para>
-	<para>
-	<command>asterisk -vvvgc</command> - Run on controlling terminal
-	</para>
-	<para>
-	<command>asterisk -rx "core show channels"</command> - Display channels on running server
-	</para>
-</refsect1>
-<refsect1>
-	<title>BUGS</title>
-	<para>
-	Bug reports and feature requests may be filed at https://issues.asterisk.org
-	</para>
-</refsect1>
-<refsect1>
-	<title>SEE ALSO</title>
-	<para>
-	*CLI&gt; <command>help</command> - Help on Asterisk CLI
-	</para>
-	<para>
-	*CLI&gt; <command>core show applications</command> - Show loaded dialplan applications
-	</para>
-	<para>
-	*CLI&gt; <command>core show functions</command> - Show loaded dialplan functions
-	</para>
-	<para>
-	*CLI&gt; <command>dialplan show</command> - Show current dialplan
-	</para>
-	<para>
-	http://www.asterisk.org - The Asterisk Home Page
-	</para>
-	<para>
-	http://www.asteriskdocs.org - The Asterisk Documentation Project
-	</para>
-	<para>
-	http://www.voip-info.org/wiki-Asterisk - The Asterisk Wiki
-	</para>
-	<para>
-	http://www.digium.com/ - Asterisk sponsor and hardware supplier
-	</para>
-</refsect1>
-<refsect1>
-	<title>AUTHOR</title>
-	<para>
-	<author>
-		<firstname>Mark Spencer &lt;markster@digium.com&gt;</firstname> 
-	</author>
-	</para>
-	<para>
-	<author>
-		<firstname>Countless other contributors, see CREDITS with distribution for more information.</firstname> 
-	</author>
-	</para>
-</refsect1>
-</refentry>
Index: asterisk.8
===================================================================
--- asterisk.8	(revision 308567)
+++ asterisk.8	(working copy)
@@ -1,229 +1,260 @@
-'\" -*- coding: us-ascii -*-
-.if \n(.g .ds T< \\FC
-.if \n(.g .ds T> \\F[\n[.fam]]
-.de URL
-\\$2 \(la\\$1\(ra\\$3
-..
-.if \n(.g .mso www.tmac
-.TH &#10;&#9;&#9;asterisk&#10;&#9; 8 2010-08-03 "asterisk 1.6" ""
-.SH NAME
-asterisk
-\- All-purpose telephony server. 
-.SH SYNOPSIS
-'nh
-.fi
-.ad l
-\fBasterisk\fR \kx
-.if (\nx>(\n(.l/2)) .nr x (\n(.l/5)
-'in \n(.iu+\nxu
-[\fB-BcdfFghiImnpqRtTvVW\fR] [\fB-C \fR\fIfile\fR] [\fB-e \fR\fImemory\fR] [\fB-G \fR\fIgroup\fR] [\fB-L \fR\fIloadaverage\fR] [\fB-M \fR\fIvalue\fR] [\fB-U \fR\fIuser\fR] [\fB-s \fR\fIsocket-file\fR] [\fB-x \fR\fIcommand\fR]
-'in \n(.iu-\nxu
-.ad b
-'hy
-'nh
-.fi
-.ad l
-\fBasterisk -r\fR \kx
-.if (\nx>(\n(.l/2)) .nr x (\n(.l/5)
-'in \n(.iu+\nxu
-[\fB-v\fR] [\fB-x \fR\fIcommand\fR]
-'in \n(.iu-\nxu
-.ad b
-'hy
-.SH DESCRIPTION
-\fBasterisk\fR is a full-featured telephony server which
-provides Private Branch eXchange (PBX), Interactive Voice Response (IVR),
-Automated Call Distribution (ACD), Voice over IP (VoIP) gatewaying, 
-Conferencing, and a plethora of other telephony applications to a broad
-range of telephony devices including packet voice (SIP, IAX2, MGCP, Skinny,
-H.323, Unistim) devices (both endpoints and proxies), as well as traditional TDM
-hardware including T1, E1, ISDN PRI, GR-303, RBS, Loopstart, Groundstart,
-ISDN BRI and many more.
-.PP
-At start, Asterisk reads the /etc/asterisk/asterisk.conf main configuration
-file and locates the rest of the configuration files from the configuration
-in that file. The -C option specifies an alternate main configuration file.
-Virtually all aspects of the operation of asterisk's configuration files
-can be found in the sample configuration files. The format for those files
-is generally beyond the scope of this man page.
-.PP
-When running with \fB-c\fR, \fB-r\fR or \fB-R\fR
-options, Asterisk supplies a powerful command line, including command
-completion, which may be used to monitors its status, perform a variety
-of administrative actions and even explore the applications that are
-currently loaded into the system.
-.PP
-Asterisk is a trademark of Digium, Inc.
-.SH OPTIONS
-.TP 
--B
-Force the background of the terminal to be black, in order for
-terminal colors to show up properly.
-.TP 
--C \fIfile\fR
-Use \*(T<\fIfile\fR\*(T> as master configuration file
-instead of the default, /etc/asterisk/asterisk.conf
-.TP 
--c
-Provide a control console on the calling terminal.
-Specifying this option implies \fB-f\fR and will cause
-asterisk to no longer fork or detach from the controlling terminal.
-.TP 
--d
-Enable extra debugging statements.
+.TH "   \fBasterisk\fP   " "8" 
+ 
+.SH "NAME" 
+\fBasterisk\fP       \(em    Open Communications Server
+ 
+ 
+.SH "SYNOPSIS" 
+ 
+.PP 
+\fBasterisk\fR \fB-BcdfFghiImnpqRtTvVW\fP \fB-C \fP\fIfile\fR \fB-e \fP\fImemory\fR \fB-G \fP\fIgroup\fR \fB-L \fP\fIloadaverage\fR \fB-M \fP\fIvalue\fR \fB-U \fP\fIuser\fR \fB-s \fP\fIsocket-file\fR     
+ 
+.PP 
+\fBasterisk \-r\fR \fB-v\fP \fB-d\fP \fB-x \fP\fIcommand\fR     
+ 
+.PP 
+\fBasterisk \-R\fR \fB-v\fP \fB-d\fP \fB-x \fP\fIcommand\fR     
+ 
+ 
+.SH "DESCRIPTION" 
+        
+.PP 
+\fBasterisk\fR is a full-featured communications server which 
+provides Private Branch eXchange (PBX), Interactive Voice Response (IVR), 
+Automated Call Distribution (ACD), Voice over IP (VoIP) gatewaying,  
+Conferencing, and a plethora of other uses to a broad 
+range of telephony devices including packet voice (SIP, IAX2, MGCP, Skinny, 
+H.323, Unistim) devices (both endpoints and proxies), as well as traditional TDM 
+hardware including T1, E1, ISDN PRI, GR-303, RBS, Loopstart, Groundstart, 
+ISDN BRI and many more. 
+ 
+.PP 
+At start, Asterisk reads the /etc/asterisk/asterisk.conf main configuration 
+file and locates the rest of the configuration files from the configuration 
+in that file. The \-C option specifies an alternate main configuration file. 
+Virtually all aspects of the operation of asterisk's configuration files 
+can be found in the sample configuration files.  The format for those files 
+is generally beyond the scope of this man page. 
+ 
+.PP 
+When running with \fB-c\fR, \fB-r\fR or \fB-R\fR options, Asterisk supplies
+a powerful command line, including command completion, which may be
+used to monitor its status, perform a variety of administrative actions
+and even explore the applications that are currently loaded into the
+system. 
+ 
+.PP 
+Asterisk is a trademark of Digium, Inc. 
+ 
+ 
+.SH "OPTIONS" 
+ 
+.PP 
+Running Asterisk starts the asterisk daemon (optionally running it 
+in the foreground). However running it with \fB-r\fP or 
+\fB-R\fP connects to an existing Asterisk instance through 
+a remote console. 
+ 
+.IP "\-B" 10 
+Force the background of the terminal to be black, in order for 
+terminal colors to show up properly. Equivalent to 
+\fBforceblackbackground = yes\fP in 
+\fBasterisk.conf\fP. See also 
+\fB-n\fP and \fB-W\fP. 
+ 
+.IP "\-C \fIfile\fR" 10 
+Use \fBfile\fP as master configuration file 
+instead of the default, /etc/asterisk/asterisk.conf 
+ 
+.IP "\-c" 10 
+Provide a control console on the calling terminal. The 
+console is similar to the remote console provided by 
+\fB-r\fP. Specifying this option implies  
+\fB-f\fR and will cause asterisk to no longer  
+fork or detach from the controlling terminal. Equivalent  
+to \fBconsole = yes\fP in \fBasterisk.conf\fP. 
+ 
+.IP "\-d" 10 
+Enable extra debugging statements. This parameter may be used several 
+times, and each increases the debug level.  Equivalent to \fBdebug = \fInum\fR\fP       in \fBasterisk.conf\fP to explicitly set the initian debug 
+level to \fInum\fR. When given at startup, this 
+option also implies \fB-f\fP (no forking). However when 
+connecting to an existing Asterisk instance (\fB-r\fP or 
+\fB-R\fP), it may only increase the debug level. 
+ 
+.IP "\-e \fImemory\fR" 10 
+Limit the generation of new channels when the amount of free memory  
+has decreased to under \fImemory\fR megabytes. 
+Equivalent to \fBminmemfree = \fImemory\fR\fP in 
+\fBasterisk.conf\fP. 
+ 
+.IP "\-f" 10 
+Do not fork or detach from controlling terminal.  Overrides any 
+preceding specification of \fB-F\fR on the command line. 
+Equivalent to \fBnofork = yes\fP in \fBasterisk.conf\fP. 
+See also \fB-c\fP. 
+ 
+.IP "\-F" 10 
+Always fork and detach from controlling terminal.  Overrides any 
+preceding specification of \fB-f\fR on the command line. 
+May also be used to prevent \fB-d\fP and \fB-v\fP to imply 
+no forking. Equivalent to \fBalwaysfork = yes\fP in \fBasterisk.conf\fP. 
+ 
+.IP "\-g" 10 
+Remove resource limit on core size, thus forcing Asterisk to dump 
+core in the unlikely event of a segmentation fault or abort signal. 
+\fBNOTE:\fR in some cases this may be incompatible 
+with the \fB-U\fR or \fB-G\fR flags. 
+ 
+.IP "\-G \fIgroup\fR" 10 
+Run as group \fIgroup\fR instead of the 
+calling group.  \fBNOTE:\fR this requires substantial work 
+to be sure that Asterisk's environment has permission to write 
+the files required for its operation, including logs, its comm 
+socket, the asterisk database, etc. 
+ 
+.IP "\-h" 10 
+Provide brief summary of command line arguments and terminate. 
+ 
+.IP "\-i" 10 
+Prompt user to intialize any encrypted private keys for IAX2 
+secure authentication during startup. 
+ 
+.IP "\-I" 10 
+Enable internal timing if DAHDI timing is available. 
+The default behaviour is that outbound packets are phase locked 
+to inbound packets. Enabling this switch causes them to be 
+locked to the internal DAHDI timer instead. 
+ 
+.IP "\-L \fIloadaverage\fR" 10 
+Limits the maximum load average before rejecting new calls.  This can 
+be useful to prevent a system from being brought down by terminating 
+too many simultaneous calls. 
+ 
+.IP "\-m" 10 
+Temporarily mutes output to the console and logs.  To return to normal, 
+use \fBlogger mute\fR. 
+ 
+.IP "\-M \fIvalue\fR" 10 
+Limits the maximum number of calls to the specified value.  This can 
+be useful to prevent a system from being brought down by terminating 
+too many simultaneous calls. 
+ 
+.IP "\-n" 10 
+Disable ANSI colors even on terminals capable of displaying them. 
+ 
+.IP "\-p" 10 
+If supported by the operating system (and executing as root), 
+attempt to run with realtime priority for increased performance and 
+responsiveness within the Asterisk process, at the expense of other 
+programs running on the same machine. 
+ 
+.IP "" 10 
+Note: \fBastcanary\fR will run concurrently with 
+\fBasterisk\fR. If \fBastcanary\fR stops 
+running or is killed, \fBasterisk\fR will slow down to 
+normal process priority, to avoid locking up the machine. 
+ 
+.IP "\-q" 10 
+Reduce default console output when running in conjunction with 
+console mode (\fB-c\fR). 
+ 
+.IP "\-r" 10 
+Instead of running a new Asterisk process, attempt to connect 
+to a running Asterisk process and provide a console interface 
+for controlling it. 
+ 
+.IP "\-R" 10 
+Much like \fB-r\fR.  Instead of running a new Asterisk process, attempt to connect 
+to a running Asterisk process and provide a console interface 
+for controlling it. Additionally, if connection to the Asterisk  
+process is lost, attempt to reconnect for as long as 30 seconds. 
+ 
+.IP "\-s \fIsocket file name\fR" 10 
+In combination with \fB-r\fR, connect directly to a specified 
+Asterisk server socket. 
+ 
+.IP "\-t" 10 
+When recording files, write them first into a temporary holding directory,  
+then move them into the final location when done. 
+ 
+.IP "\-T" 10 
+Add timestamp to all non-command related output going to the console 
+when running with verbose and/or logging to the console. 
+ 
+.IP "\-U \fIuser\fR" 10 
+Run as user \fIuser\fR instead of the 
+calling user.  \fBNOTE:\fR this requires substantial work 
+to be sure that Asterisk's environment has permission to write 
+the files required for its operation, including logs, its comm 
+socket, the asterisk database, etc. 
+ 
+.IP "\-v" 10 
+Increase the level of verboseness on the console.  The more times 
+\fB-v\fR is specified, the more verbose the output is. 
+Specifying this option implies \fB-f\fR and will cause 
+asterisk to no longer fork or detach from the controlling terminal. 
+This option may also be used in conjunction with \fB-r\fR       and \fB-R\fR. 
+ 
+.IP "" 10 
+Note: This always sets the verbose level in the asterisk process, 
+even if it is running in the background. This will affect the size 
+of your log files. 
+ 
+.IP "\-V" 10 
+Display version information and exit immediately. 
+ 
+.IP "\-W" 10 
+Display colored terminal text as if the background were white 
+or otherwise light in color.  Normally, terminal text is displayed 
+as if the background were black or otherwise dark in color. 
+ 
+.IP "\-x \fIcommand\fR" 10 
+Connect to a running Asterisk process and execute a command on 
+a command line, passing any output through to standard out and 
+then terminating when the command execution completes.  Implies 
+\fB-r\fR when \fB-R\fR is not explicitly 
+supplied. 
+ 
+.IP "\-X" 10 
+Enables executing of includes via \fB#exec\fR directive. 
+This can be useful if You want to do \fB#exec\fR inside 
+\fBasterisk.conf\fP                     
+ 
+.SH "EXAMPLES" 
+ 
+.PP 
+\fBasterisk\fR \- Begin Asterisk as a daemon 
+ 
+.PP 
+\fBasterisk \-vvvgc\fR \- Run on controlling terminal 
+ 
+.PP 
+\fBasterisk \-rx "core show channels"\fR \- Display channels on running server 
+ 
+ 
+.SH "BUGS" 
+ 
+.PP 
+Bug reports and feature requests may be filed at https://issues.asterisk.org 
+ 
+ 
+.SH "SEE ALSO" 
+ 
+.PP 
+http://www.asterisk.org \- The Asterisk Home Page 
 
-Note: This always sets the debug level in the asterisk process,
-even if it is running in the background. This may affect the size
-of your log files, if the debug level is specified in logger.conf.
-.TP 
--e \fImemory\fR
-Limit the generation of new channels when the amount of free memory has decreased to under \fImemory\fR megabytes.
-.TP 
--f
-Do not fork or detach from controlling terminal. Overrides any preceding specification of \fB-F\fR on the command line.
-.TP 
--F
-Always fork and detach from controlling terminal. Overrides any preceding specification of \fB-f\fR on the command line.
-.TP 
--g
-Remove resource limit on core size, thus forcing Asterisk to dump
-core in the unlikely event of a segmentation fault or abort signal.
-\fBNOTE:\fR in some cases this may be incompatible
-with the \fB-U\fR or \fB-G\fR flags.
-.TP 
--G \fIgroup\fR
-Run as group \fIgroup\fR instead of the
-calling group. \fBNOTE:\fR this requires substantial work
-to be sure that Asterisk's environment has permission to write
-the files required for its operation, including logs, its comm
-socket, the asterisk database, etc.
-.TP 
--h
-Provide brief summary of command line arguments and terminate.
-.TP 
--i
-Prompt user to intialize any encrypted private keys for IAX2
-secure authentication during startup.
-.TP 
--I
-Enable internal timing if DAHDI timing is available.
-The default behaviour is that outbound packets are phase locked
-to inbound packets. Enabling this switch causes them to be
-locked to the internal DAHDI timer instead.
-.TP 
--L \fIloadaverage\fR
-Limits the maximum load average before rejecting new calls. This can
-be useful to prevent a system from being brought down by terminating
-too many simultaneous calls.
-.TP 
--m
-Temporarily mutes output to the console and logs. To return to normal,
-use \fBlogger mute\fR.
-.TP 
--M \fIvalue\fR
-Limits the maximum number of calls to the specified value. This can
-be useful to prevent a system from being brought down by terminating
-too many simultaneous calls.
-.TP 
--n
-Disable ANSI colors even on terminals capable of displaying them.
-.TP 
--p
-If supported by the operating system (and executing as root),
-attempt to run with realtime priority for increased performance and
-responsiveness within the Asterisk process, at the expense of other
-programs running on the same machine.
-
-Note: \fBastcanary\fR will run concurrently with
-\fBasterisk\fR. If \fBastcanary\fR stops
-running or is killed, \fBasterisk\fR will slow down to
-normal process priority, to avoid locking up the machine.
-.TP 
--q
-Reduce default console output when running in conjunction with
-console mode (\fB-c\fR).
-.TP 
--r
-Instead of running a new Asterisk process, attempt to connect
-to a running Asterisk process and provide a console interface
-for controlling it.
-.TP 
--R
-Much like \fB-r\fR. Instead of running a new Asterisk process, attempt to connect
-to a running Asterisk process and provide a console interface
-for controlling it. Additionally, if connection to the Asterisk 
-process is lost, attempt to reconnect for as long as 30 seconds.
-.TP 
--s \fIsocket file name\fR
-In combination with \fB-r\fR, connect directly to a specified
-Asterisk server socket.
-.TP 
--t
-When recording files, write them first into a temporary holding directory, 
-then move them into the final location when done.
-.TP 
--T
-Add timestamp to all non-command related output going to the console
-when running with verbose and/or logging to the console.
-.TP 
--U \fIuser\fR
-Run as user \fIuser\fR instead of the
-calling user. \fBNOTE:\fR this requires substantial work
-to be sure that Asterisk's environment has permission to write
-the files required for its operation, including logs, its comm
-socket, the asterisk database, etc.
-.TP 
--v
-Increase the level of verboseness on the console. The more times
-\fB-v\fR is specified, the more verbose the output is.
-Specifying this option implies \fB-f\fR and will cause
-asterisk to no longer fork or detach from the controlling terminal.
-This option may also be used in conjunction with \fB-r\fR
-and \fB-R\fR.
-
-Note: This always sets the verbose level in the asterisk process,
-even if it is running in the background. This will affect the size
-of your log files.
-.TP 
--V
-Display version information and exit immediately.
-.TP 
--W
-Display colored terminal text as if the background were white
-or otherwise light in color. Normally, terminal text is displayed
-as if the background were black or otherwise dark in color.
-.TP 
--x \fIcommand\fR
-Connect to a running Asterisk process and execute a command on
-a command line, passing any output through to standard out and
-then terminating when the command execution completes. Implies
-\fB-r\fR when \fB-R\fR is not explicitly
-supplied.
-.SH EXAMPLES
-\fBasterisk\fR - Begin Asterisk as a daemon
-.PP
-\fBasterisk -vvvgc\fR - Run on controlling terminal
-.PP
-\fBasterisk -rx "core show channels"\fR - Display channels on running server
-.SH BUGS
-Bug reports and feature requests may be filed at https://issues.asterisk.org
-.SH "SEE ALSO"
-*CLI> \fBhelp\fR - Help on Asterisk CLI
-.PP
-*CLI> \fBcore show applications\fR - Show loaded dialplan applications
-.PP
-*CLI> \fBcore show functions\fR - Show loaded dialplan functions
-.PP
-*CLI> \fBdialplan show\fR - Show current dialplan
-.PP
-http://www.asterisk.org - The Asterisk Home Page
-.PP
-http://www.asteriskdocs.org - The Asterisk Documentation Project
-.PP
-http://www.voip-info.org/wiki-Asterisk - The Asterisk Wiki
-.PP
-http://www.digium.com/ - Asterisk sponsor and hardware supplier
-.SH AUTHOR
-Mark Spencer <markster@digium.com>
-.PP
-Countless other contributors, see CREDITS with distribution for more information.
+.PP 
+http://wiki.asterisk.org \- The Asterisk Wiki 
+ 
+.PP 
+http://www.digium.com/ \- Asterisk is sponsored by Digium 
+ 
+ 
+.SH "AUTHOR" 
+ 
+.PP 
+Mark Spencer markster@digium.com   
+ 
+.PP 
+Countless other contributors, see \fBCREDITS\fP with distribution for more information.
Index: Makefile
===================================================================
--- Makefile	(revision 308567)
+++ Makefile	(working copy)
@@ -1,6 +0,0 @@
-
-all: asterisk.8
-
-asterisk.8: asterisk.sgml
-	docbook2X-man asterisk.sgml
-